
package stamp.peripheral.sensor.GPS.StringOperations;
import stamp.core.*;

// PE.060205. Class used in the GPS string operations
public class StringOperations
{

  // This function searches for first occurence of the "szChar" starting at the position
  // "iIndexStart" and returns the postion if it could be found or "-1" if the
  // character could not be found
  public static int IndexOfNext( int iIndexStart, char[] str, char szChar )
  {
    if ( str.length > iIndexStart )
    {
      for ( int i = iIndexStart; i < str.length; i++ )
        if ( str[i] == szChar )
          return (i);
    }
      return (-1);
  }

  public static void ClearBuffer( StringBuffer buffer )
  {
    char[] szArray = buffer.toString().toCharArray();
    int nLength = szArray.length;

    for ( int i = 0; i < nLength; i++ )
     szArray[i] = '0';
  }
  // Searches backward efter the "$" and returns "true" if a message could be found
  public static int GetGPSMessage( StringBuffer msgBuffer, int nFirstPos, int nLastPos, StringBuffer strReturnMessage )
  {
    strReturnMessage.clear();
    //FillBuffer( strReturnMessage );

    for ( int i = nLastPos; i >=nFirstPos; i-- )
    {
      char ch = msgBuffer.charAt(i);

      if ( ch == '$')
      {
        msgBuffer.subString( i, nLastPos+1, strReturnMessage );
        return i; // Where we found the message
      }
    }

    // "6" is the lenght of a GPS NMEA0183 ID...
    return ( -1 );
  }
}