
package stamp.peripheral.sensor.GPS.Temperature;

import stamp.core.*;
import stamp.peripheral.sensor.humidity.sht11.*;
import stamp.peripheral.sensor.GPS.DisplayDriver.*;

public class Temperature
{
  static int rawHum, relHum;
  static int rawTemp,celsius;

  private sht11 m_sht = null;

  public Temperature(sht11 sht)
  {
    m_sht = sht;
  }
  /*
  public void MeasureTempAndHumidity(StringBuffer buffer)
  {
    MeasureTemp(buffer);
    buffer.append("/");
    MeasureHumidity(buffer);
  }
  */
  /*
  // Function returns the relative humidity
  public boolean MeasureHumidity(StringBuffer buffer)
  {
    rawHum = m_sht.rawHumidity();
    relHum = m_sht.relHumidity(rawHum);

    buffer.append(relHum/10);
    buffer.append(".");
    buffer.append(relHum%10);
    buffer.append("%");

    return (true);
  }
  */

  // Function measures the temperature and returns it in the "buffer"
  public boolean MeasureTemp(StringBuffer buffer)
  {
    rawTemp = m_sht.rawTemp();
    if (rawTemp < 0)
    {
      // Something is wrong with the communications...
      // since we're getting in a negative value.
      // Reset the connection to SHT11
      m_sht.connectionReset();
      rawTemp = m_sht.rawTemp();
      if (rawTemp<0) return (false);
    }

    celsius = m_sht.celsius(rawTemp);
    buffer.append(celsius/10);
    buffer.append(".");
    buffer.append(celsius%10);
    buffer.append((char)DisplayDriver.SPECIAL_CHARACTER_DEGREE);
    buffer.append("C");

    return (true);
  }
}